/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.0(de787e7356906c106794ba30a2414816033d8bd1)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var e=["exports","require","vs/base/common/marked/marked","vs/editor/common/modes/textToHtmlTokenizer","vs/base/common/strings","vs/editor/common/modes/nullMode","vs/languages/markdown/common/markdownWorker","vs/platform/markers/common/markers","vs/base/common/uri","vs/base/common/types","vs/base/common/paths","vs/base/common/platform","vs/editor/common/services/modeService","vs/editor/common/services/resourceService","vs/base/common/winjs.base"],t=function(t){for(var r=[],n=0,o=t.length;o>n;n++)r[n]=e[t[n]];return r};define(e[2],t([1,0]),function(e,t){"use strict";function r(e){return e}r.Renderer=function(){};var n={marked:r};return n}),define(e[3],t([1,0,4,5]),function(e,t,r,n){"use strict";function o(e,t){return a(e,s(t))}function i(e,t,r){return c(e,s(t),r)}function s(e){return e&&e.tokenizationSupport?e.tokenizationSupport:{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new n.NullState(null,null)},tokenize:function(e,t,r,o){return void 0===r&&(r=0),n.nullTokenize(null,e,t,r,o)}}}function a(e,t){var r={tagName:"div",style:"white-space: pre-wrap",children:[]},n=function(e,t){r.children.push({tagName:"span",className:e,text:t})},o=function(){r.children.push({tagName:"br"})};return l(e,t,n,o),r}function c(e,t,n){void 0===n&&(n=""),n&&n.length>0&&(n=" "+n);var o="",i=function(e,t){o+='<span class="'+e+n+'">'+r.escape(t)+"</span>"},s=function(){o+="<br/>"};return o='<div style="white-space: pre-wrap;">',l(e,t,i,s),o+="</div>"}function l(e,t,r,n){for(var o=e.split(/\r\n|\r|\n/),i=t.getInitialState(),s=0;s<o.length;s++)i=u(o[s],t,r,i),s<o.length-1&&n()}function u(e,t,r,n){for(var o,i=t.tokenize(e,n),s=i.endState,a=i.tokens,c=0,l=0;l<a.length;l++){var u=a[l];l<a.length-1?(o=e.substring(c,a[l+1].startIndex),c=a[l+1].startIndex):o=e.substr(c);var h="token",m=u.type.replace(/[^a-z0-9\-]/gi," ");m.length>0&&(h+=" "+m),r(h,o)}return s}t.tokenizeToHtmlContent=o,t.tokenizeToString=i});var r=this&&this.__decorate||function(e,t,r,n){var o,i=arguments.length,s=3>i?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,n);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(3>i?o(s):i>3?o(t,r,s):o(t,r))||s);return i>3&&s&&Object.defineProperty(t,r,s),s},n=this&&this.__param||function(e,t){return function(r,n){t(r,n,e)}};define(e[6],t([1,0,14,8,9,10,2,3,11,12,13,7]),function(e,t,o,i,s,a,c,l,u,h,m,d){"use strict";var b;!function(e){e[e.LIGHT=0]="LIGHT",e[e.DARK=1]="DARK",e[e.HC_BLACK=2]="HC_BLACK"}(b||(b={}));var f=function(){function e(e,t,r,n){this.theme=b.DARK,this._modeId=e,this.resourceService=t,this.markerService=r,this.modeService=n}return e.prototype._doConfigure=function(e){return e&&e.theme&&(this.theme="vs-dark"===e.theme?b.DARK:"vs"===e.theme?b.LIGHT:b.HC_BLACK),e&&s.isArray(e.styles)&&(this.cssLinks=e.styles),o.TPromise.as(void 0)},e.prototype.getEmitOutput=function(t,r){var n=this,i=this.resourceService.get(t),s=this.cssLinks||[],a=new c.marked.Renderer,h=this;a.image=function(e,r,n){var o='<img src="'+h.fixHref(t,e)+'" alt="'+n+'"';return r&&(o+=' title="'+r+'"'),o+=this.options&&this.options.xhtml?"/>":">"};var m=a.link;a.link=function(e,t,r){var n=m.call(this,e,t,r);return n=e&&"#"===e[0]?n.replace("href=","localhref="):n.replace("<a",'<a target="_blank"')};var d=this.modeService,f=function(t,r,n){var o=d.getModeIdForLanguageName(r)||r||e.DEFAULT_MODE;d.getOrCreateMode(o).then(function(e){n(null,l.tokenizeToString(t,e))})};return new o.Promise(function(o,l){c.marked(i.getValue(),{gfm:!0,renderer:a,highlight:f},function(i,a){var c=["<!DOCTYPE html>","<html>","<head>",'<meta http-equiv="Content-type" content="text/html;charset=UTF-8">',0===s.length?'<link rel="stylesheet" href="'+r+'/markdown.css" type="text/css" media="screen">':"",0===s.length?'<link rel="stylesheet" href="'+r+'/tokens.css" type="text/css" media="screen">':"",n.theme===b.LIGHT?e.LIGHT_SCROLLBAR_CSS:n.theme===b.DARK?e.DARK_SCROLLBAR_CSS:e.HC_BLACK_SCROLLBAR_CSS,s.map(function(e){return'<link rel="stylesheet" href="'+n.fixHref(t,e)+'" type="text/css" media="screen">'}).join("\n"),"</head>",u.isMacintosh?'<body class="mac">':"<body>"].join("\n"),l=[n.theme===b.LIGHT?'<div class="monaco-editor vs">':n.theme===b.DARK?'<div class="monaco-editor vs-dark">':'<div class="monaco-editor hc-black">',a,"</div>"].join("\n"),h=["</body>","</html>"].join("\n");o({head:c,body:l,tail:h})})})},e.prototype.fixHref=function(e,t){return t?i["default"].parse(t).scheme?t:i["default"].file(a.join(a.dirname(e.fsPath),t)).toString():t},e.DEFAULT_MODE="text/plain",e.LIGHT_SCROLLBAR_CSS=['<style type="text/css">',"	::-webkit-scrollbar {","		width: 14px;","		height: 14px;","	}","","	::-webkit-scrollbar-thumb {","		background-color: rgba(100, 100, 100, 0.4);","	}","","	::-webkit-scrollbar-thumb:hover {","		background-color: rgba(100, 100, 100, 0.7);","	}","","	::-webkit-scrollbar-thumb:active {","		background-color: rgba(0, 0, 0, 0.6);","	}","</style>"].join("\n"),e.DARK_SCROLLBAR_CSS=['<style type="text/css">',"	::-webkit-scrollbar {","		width: 14px;","		height: 14px;","	}","","	::-webkit-scrollbar-thumb {","		background-color: rgba(121, 121, 121, 0.4);","	}","","	::-webkit-scrollbar-thumb:hover {","		background-color: rgba(100, 100, 100, 0.7);","	}","","	::-webkit-scrollbar-thumb:active {","		background-color: rgba(85, 85, 85, 0.8);","	}","</style>"].join("\n"),e.HC_BLACK_SCROLLBAR_CSS=['<style type="text/css">',"	::-webkit-scrollbar {","		width: 14px;","		height: 14px;","	}","","	::-webkit-scrollbar-thumb {","		background-color: rgba(111, 195, 223, 0.3);","	}","","	::-webkit-scrollbar-thumb:hover {","		background-color: rgba(111, 195, 223, 0.4);","	}","","	::-webkit-scrollbar-thumb:active {","		background-color: rgba(111, 195, 223, 0.4);","	}","</style>"].join("\n"),e=r([n(1,m.IResourceService),n(2,d.IMarkerService),n(3,h.IModeService)],e)}();t.MarkdownWorker=f})}).call(this);
//# sourceMappingURL=../../../../../min-maps/vs/languages/markdown/common/markdownWorker.js.map